#pragma once

/**
 * Initialises the random number generation system.
 * It's important to do this as early as possible, as it takes a while to 
 * gather the necessary entropy in order to actually generate a random number.
 */
void random_begin();

// FUTURE: Swap this out for LoRa untuned wideband radio static?

/**
 * Gets an unsigned 32-bit random number.
 * @return	{uint32_t}	A random number.
 */
uint32_t random_get();
